/**
 * demo.js
 * https://coidea.website
 *
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 * 
 * Copyright 2018, COIDEA
 * https://coidea.website
 */

  // images loaded
  $('.coidea-slider').imagesLoaded({ background: true }, function() {

    // hide loader
    $('.loader').addClass('is-loaded');
    
    // Variables
    let $slide = $('.slide'),
        $slideActive = $('.slide.is-active'),
        $slideNavigation = $('.slides-navigation'),
        $mainNavLink = $('.main-nav__link'),
        $body = $('body')
    
    function init() {
      // Make active slide visible
      TweenLite.set($slideActive, {autoAlpha: 1})
      TweenLite.set($slideActive.find('.slide__background'), {autoAlpha: 1, y: "0%"})
      TweenLite.set($slideActive.find('.slide__content'), {autoAlpha: 1, y: "0%"})
      
      // Fade slide in
      TweenLite.set($body, {className: '-=is-loading'})
      
      // add disabled class to all navigation items except next one 
      $mainNavLink.each(function(){
        $(this).addClass('disabled');
        $(this).removeClass('next');
        if( $(this).data('id') == 1 ) {
          $(this).removeClass('disabled');
          $(this).addClass('next');
        }
      })
      
    }
    
    init();
    
    // Navigation functionality ========
    var $counter = 0;
    $slideNavigation.on('click', '.main-nav__link', function(event) {
      event.preventDefault();

      if (!($body.hasClass('is-animating'))) {
      
        if( $('.main-nav__link.is-active').data('id') > $(this).data('id') ) {
          $counter = $counter - 180;
        } else {
          $counter = $counter + 180;
        }
        
        let sectionFromId = $('.slide.is-active').attr('id'),
            sectionToId = $(this).attr('href'),
            $sectionFrom = $('.slide.is-active'),
            $sectionTo = $(sectionToId)

        if (sectionFromId !== sectionToId) {
          scrollToSection($sectionFrom, $sectionTo)
        }
      }
    })
    
    // Scroll To Section functionality
    function scrollToSection(sectionFrom, sectionTo) {
      let background = $('.slides-background'),
          iphone = $('.image'),
          iphoneBcg = sectionTo.data('bcg'),
          titleLeft = sectionTo.find('.slide__title_left'),
          subtitleLeft = sectionTo.find('.slide__subtitle_left'),
          titleRight = sectionTo.find('.slide__title_right'),
          subtitleRight = sectionTo.find('.slide__subtitle_right'),
          contentLeft = sectionTo.find('.slide__content_left'),
          contentLeftFrom = sectionFrom.find('.slide__content_left'),
          contentRight = sectionTo.find('.slide__content_right'),
          contentRightFrom = sectionFrom.find('.slide__content_right'),
          tlScrollDown = new TimelineMax({onComplete: setActiveSection(sectionFrom, sectionTo)}),
          tlScrollUp = new TimelineMax();
      
      if (sectionFrom.index() < sectionTo.index()) {
        // Scroll Down
        tlScrollDown
          .set($body, {className: '+=is-animating'})
          .set(sectionTo, {autoAlpha: 1})
          .to(sectionFrom, 1.2, {autoAlpha: 0, ease: Power4.easeInOut }, '0')
          .to(sectionTo, 1.2, {autoAlpha: 1, ease: Power4.easeInOut }, '0')
          .to(background, 1.2, {rotation: $counter, transformStyle:"preserve-3d", ease: Expo.easeInOut }, '0')
          .to(iphone, 0.6, { autoAlpha: 0, ease: Expo.easeInOut }, 0.6 )
          .set(iphone, { backgroundImage: 'url(' + iphoneBcg + ')' } )
          .fromTo(iphone, 0.6, { autoAlpha: 0 }, { autoAlpha: 1, ease: Expo.easeInOut }, '+=0.15')
          // left
          .from(titleLeft, 0.35, {autoAlpha: 0, y: 40, ease: Power4.easeInOut}, '-=0.35')
          .from(subtitleLeft, 0.35, {autoAlpha: 0, y: 40, ease: Power4.easeInOut}, '-=0.35')
          .to(contentLeftFrom, 1.2, {autoAlpha: 0, y: '-100%', ease: Expo.easeInOut, clearProps: 'y'}, '0')
          .fromTo(contentLeft, 1.2, {autoAlpha: 0, y: '100%'}, {autoAlpha: 1, y: '0%', ease: Expo.easeInOut }, '0')
          // right
          .from(titleRight, 0.35, {autoAlpha: 0, y: -40, ease: Power4.easeInOut}, '-=0.35')
          .from(subtitleRight, 0.35, {autoAlpha: 0, y: -40, ease: Power4.easeInOut}, '-=0.35')
          .to(contentRightFrom, 1.2, {autoAlpha: 0, y: '100%', ease: Expo.easeInOut, clearProps: 'y'}, '0')
          .fromTo(contentRight, 1.2, {autoAlpha: 0, y: '-100%'}, {autoAlpha: 1, y: '0%', ease: Expo.easeInOut }, '0')
          .set($body, {className: '-=is-animating'});
      } else {
        // Scroll Up
        tlScrollUp
        .set($body, {className: '+=is-animating'})
        .set(sectionTo, {autoAlpha: 1})
        .to(sectionFrom, 1.2, {autoAlpha: 0, ease: Power4.easeInOut }, '0')
        .to(sectionTo, 1.2, {autoAlpha: 1, ease: Power4.easeInOut }, '0')
        .to(background, 1.2, {rotation: $counter, transformStyle:"preserve-3d", ease: Expo.easeInOut }, '0')
        .to(iphone, 0.6, { autoAlpha: 0, ease: Expo.easeInOut }, 0.6)
        .set(iphone, { backgroundImage: 'url(' + iphoneBcg + ')' } )
        .fromTo(iphone, 0.6, { autoAlpha: 0 }, { autoAlpha: 1, ease: Expo.easeInOut }, '+=0.15')
        // left
        .from(titleLeft, 0.35, {autoAlpha: 0, y: -40, ease: Power4.easeInOut}, '-=0.35')
        .from(subtitleLeft, 0.35, {autoAlpha: 0, y: -40, ease: Power4.easeInOut}, '-=0.35')
        .to(contentLeftFrom, 1.2, {autoAlpha: 0, y: '100%', ease: Expo.easeInOut, clearProps: 'y'}, '0')
        .fromTo(contentLeft, 1.2, {autoAlpha: 0, y: '-100%'}, {autoAlpha: 1, y: '0%', ease: Expo.easeInOut }, '0')
        // right
        .from(titleRight, 0.35, {autoAlpha: 0, y: 40, ease: Power4.easeInOut}, '-=0.35')
        .from(subtitleRight, 0.35, {autoAlpha: 0, y: 40, ease: Power4.easeInOut}, '-=0.35')
        .to(contentRightFrom, 1.2, {autoAlpha: 0, y: '-100%', ease: Expo.easeInOut, clearProps: 'y'}, '0')
        .fromTo(contentRight, 1.2, {autoAlpha: 0, y: '100%'}, {autoAlpha: 1, y: '0%', ease: Expo.easeInOut }, '0')
        .set($body, {className: '-=is-animating'});
      }
    
    }
    
    // Set active navigation
    function setActiveSection(sectionFrom, sectionTo) {
      let sectionToId = sectionTo.attr('id')
    
      // Add active class to current slide
      sectionFrom.removeClass('is-active')
      sectionTo.addClass('is-active')
      
      // Highlight current slide in navigation
      let currentSlideIndex = parseInt(sectionToId.slice(-2)) - 1
      $slideNavigation.find('.main-nav__link').removeClass('is-active')
      $slideNavigation.find('.main-nav__link[data-id=' + currentSlideIndex + ']').addClass('is-active')
      
      // Disable/enable items and add navigation arrows at the right place
      $mainNavLink.each(function(){
        $(this).removeClass('disabled');
        $(this).removeClass('prev next');
        if( currentSlideIndex-1 > $(this).data('id') || currentSlideIndex+1 < $(this).data('id') || currentSlideIndex == $(this).data('id') ) {
          $(this).addClass('disabled');
        }
        if( currentSlideIndex-1 == $(this).data('id') ) {
          $(this).addClass('prev');
        }
        if( currentSlideIndex+1 == $(this).data('id') ) {
          $(this).addClass('next');
        }
      })
    
    }
    
  });